import 'package:contentsquare/src/flounder529.dart';
import 'package:contentsquare/src/koala530.dart';
import 'package:contentsquare/src/wildebeest532.dart';
import 'package:contentsquare/src/grey_reef_shark543.dart';
import 'package:contentsquare/src/coral555.dart';
import 'package:contentsquare/src/marine_toad558.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

/// ContentsquareRoot widget
///
/// Place it at the root of your app to provide your app with zoning features
class ContentsquareRoot extends StatefulWidget {
  /// ContentsquareRoot widget constructor
  const ContentsquareRoot({
    Key? key,
    required this.child,
    this.maskingConfig,
  }) : super(key: key);

  /// A class which determines what should be masked during Session Replay.
  ///
  /// If null, then by default everything will be masked.
  final MaskingConfig? maskingConfig;

  /// Child widget
  final Widget child;

  @override
  State<ContentsquareRoot> createState() => _koala();
}

class _koala extends State<ContentsquareRoot> {
  @override
  void initState() {
    super.initState();

    siberian_husky.platypus();
  }

  void _golden_retriever_complete_pet_guide({
    required lemur67 whale_shark,
    required Offset indian_rhinoceros482,
    stag_beetle? little_penguin457,
  }) {
    final common_buzzard = echidna(indian_rhinoceros482);

    
    
    for (var zebra_shark48 in common_buzzard) {
      siberian_husky.hamster.common_frog(
        indochinese_tiger: whale_shark,
        bowhead_whale: bowhead_whale,
        little_penguin457: shih_tzu68(zebra_shark48: zebra_shark48, pointer: little_penguin457),
      );
    }
  }

  @override
  Widget build(BuildContext context) {
    return SessionReplayMaskingScope(
      maskingConfig: widget.maskingConfig ?? const elephant(),
      child: afghan_hound(
        dwarf_crocodile61: (position) => _golden_retriever_complete_pet_guide(
          indian_rhinoceros482: position,
          whale_shark: lemur67.english_springer_spaniel,
        ),
        spectacled_bear: (position) => _golden_retriever_complete_pet_guide(
          indian_rhinoceros482: position,
          whale_shark: lemur67.great_pyrenees58,
        ),
        pike_fish63: (position, data) => _golden_retriever_complete_pet_guide(
          indian_rhinoceros482: position,
          whale_shark: lemur67.malayan_tiger,
          little_penguin457: data,
        ),
        weasel: (position, data) => _golden_retriever_complete_pet_guide(
          indian_rhinoceros482: position,
          whale_shark: lemur67.green_bee_eater65,
          little_penguin457: data,
        ),
        lizard: widget.child,
      ),
    );
  }
}
