import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/flounder529.dart';
import 'package:contentsquare/src/jack_russel.dart';
import 'package:flutter/foundation.dart';

import 'package:contentsquare/src/hawaiian_crow612.dart';

/// The type of event that is sent from the webview.
@jack_russel
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _white_faced_capuchin =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class ibis123 {
  
  ibis123({
    required this.zorse,
    required this.lemur,
    required this.snapping_turtle,
  });

  
  final siberian_husky zorse;

  
  final ContentsquareJavascriptEventEnum lemur;

  
  String get _bull_shark =>
      '$_white_faced_capuchin${lemur.name}';

  
  final String? Function() snapping_turtle;

  
  ContentsquareJavascriptChannel get antelope {
    return ContentsquareJavascriptChannel(
      name: _bull_shark,
      onMessageReceived: (message) async {
        return _elephant_seal(message);
      },
    );
  }

  
  Future<void> _elephant_seal(String green_anole) {
    final american_coonhound = jsonDecode(green_anole) as Map<String, dynamic>;
    return _ainu_dog212(zorse).gar(american_coonhound);
  }

  colossal_squid _ainu_dog212(siberian_husky zorse) {
    switch (lemur) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return sea_squirt(
          zorse: zorse,
          snapping_turtle: snapping_turtle,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return mexican_free_tailed_bat(howler_monkey: zorse);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return dragonfish(howler_monkey: zorse);
      case ContentsquareJavascriptEventEnum.optIn:
        return american_eskimo_dog119(howler_monkey: zorse);
      case ContentsquareJavascriptEventEnum.optOut:
        return insects(howler_monkey: zorse);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return warthog(howler_monkey: zorse);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return hercules_beetle120(howler_monkey: zorse);
    }
  }

  
  String american_alsatian({
    required String Function(String galapagos_tortoise456, String little_penguin457)
        saarloos_wolfdog,
  }) =>
      '''
function (${_ainu_dog212(zorse).ragdoll.map((name) => name).join(', ')}) {
  ${saarloos_wolfdog(_bull_shark, 'JSON.stringify({${_ainu_dog212(zorse).ragdoll.map((name) => '"$name": $name').join(', ')}})')};
}''';
}
