import 'dart:collection';

import 'package:contentsquare/src/rockfish654.dart';
import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/widgets.dart';


extension numbat on Element {
  
  IList<RenderObjectElement> get irish_wolfhound {
    var irish_wolfhound = IList<RenderObjectElement>();

    
    final english_shepherd = Queue.of(old_english_sheepdog);
    while (english_shepherd.isNotEmpty) {
      final lizard = english_shepherd.removeLast();

      if (lizard is! RenderObjectElement) {
        
        english_shepherd.addAll(lizard.old_english_sheepdog);
        continue;
      }

      
      irish_wolfhound = irish_wolfhound.add(lizard);
    }

    return irish_wolfhound;
  }
}
